//
// 2016.05 Kyoung Shin Park 
//
//#include <TCHAR.h>
#include <stdio.h>
#include <windows.h>
#include "SharedMemory.h"
#define MAX_SEM_COUNT 1

CSharedMemory::CSharedMemory(string name)
{
	m_SharedMemoryName = "SHARED_MEMORY" + name;
	m_Created = true;
}

HANDLE CSharedMemory::getShm(key_t key, size_t size, int shmflg)
{
	//TCHAR memoryMapName[256];
	DWORD flag = 0;

	if (key == IPC_PRIVATE || (shmflg & IPC_CREAT)) {
		//WaitForSingleObject(m_hKeyMutex, INFINITE);
		//_stprintf(memoryMapName, "SHAREDMEMORY%d", KeyValue);
		//KeyValue++; 
		//ReleaseMutex(m_hKeyMutex);

		if (shmflg & S_IWUSR) 
			flag = PAGE_READWRITE;
		else if (shmflg & S_IRUSR)
			flag = PAGE_READONLY;
		printf("shared memory name = %s\n", m_SharedMemoryName.c_str());
		m_hMemory = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, flag, 0, size, m_SharedMemoryName.c_str());
		if (m_hMemory == NULL) {
			int error = GetLastError();
			if (error == ERROR_DISK_FULL) {
				//errno = ENOMEM;
				return NULL;
			}
		}
		else if (GetLastError() == ERROR_ALREADY_EXISTS) {
			if (shmflg & IPC_EXCL) {
				//errno = EEXIST;
				return NULL;
			}
			else {
				m_Created = false;
			}
		}
		return m_hMemory;
	}
	else {
		m_Created = false;
		if (shmflg & S_IWUSR) 
			flag |= FILE_MAP_WRITE;
		if (shmflg & S_IRUSR)
			flag |= FILE_MAP_READ;
		m_hMemory = OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE, m_SharedMemoryName.c_str());
		if (m_hMemory == NULL) {
			//errno = ENOENT;
			return NULL;
		}
		return m_hMemory;
	}
	return NULL;

}

int CSharedMemory::cleanShm(HANDLE shmid, int cmd, struct shmid_ds *buf)
{
	if (cmd == IPC_RMID) {
		if (shmid) {
			CloseHandle(shmid);
			return 0;
		}
		return -1;
	}
	return -1;
}

void * CSharedMemory::attachShm(HANDLE shmid, const void *shmaddr, int shmflg)
{
	if (shmid) {
		void *ptr = MapViewOfFile(shmid, FILE_MAP_ALL_ACCESS, 0, 0, 0);
		if (ptr) return ptr;
	}
	return NULL;
}

int CSharedMemory::detachShm(const void *shmaddr)
{
	if (UnmapViewOfFile(shmaddr)) return 0;
	return -1;
}

bool CSharedMemory::isCreated() const
{
	return m_Created;
}
